{****************************************************}
{}
{	CBDApp.p																										}
{}
{	Application class for BD.																				}
{}
{	Copyright  1996 by Patrick C Hew. All rights reserved.								}
{}
{****************************************************}


unit CBDApp;

interface

	uses
		TCL, BDIntf;

implementation

	const
		kExtraMasters = 4;			(* number of extra master pointer blocks *)
		kRainyDay = 32000;			(* total rainy day memory reserve size	 *)
		kCriticalBalance = 30000;	(* portion of rainy day for critical operations *)
		kToolboxBalance = 20000;	(* portion of rainy day for toolbox reserve *)


{****************************************************}
{}
{	IBDApp																											}
{}
{	Initialize an BD Application object.																	}
{}
{****************************************************}

	procedure CBDApp.IBDApp;

		var
			theBDDirector: CBDDirector;

	begin { IBDApp }
		IGameApp(kExtraMasters, kRainyDay, kCriticalBalance, kToolboxBalance);

		new(theBDDirector);
		theBDDirector.IBDDirector(SELF);
	end; { IBDApp }


{****************************************************}
{}
{	DoCommand																									}
{}
{	Implements a very simple About box.																}
{}
{****************************************************}

	procedure CBDApp.DoCommand (theCommand: longint);

	begin { DoCommand }
		if theCommand = cmdAbout then begin
			SATReportStr('Sprite Animation Toolkit 2.3b4 used with the THINK Class Library 1.1.2 (Pascal).');
		end { if }
		else begin
			inherited DoCommand(theCommand);
		end; { else }
	end; { DoCommand }


end. { CBDApp }