Unit ObjIntf;

Interface

Type
	TObject = OBJECT
		Function	ShallowClone: TObject;
			{	Lowest level method for copying an object;
				should not be overridden except in very
				unusual cases. Simply calls HandToHand to copy
				the object data.
			}
		Function	Clone: TObject;
			{	Defaults to calling ShallowClone; can be
				overridden to copy objects refered to by fields.
			}
		Procedure	ShallowFree;
			{	Lowest level method for freeing an object;
				should not be overridden except in very
				unusual cases. Simply calls DisposHandle to
				free the object data.
			}
		Procedure	Free;
			{	Defaults to calling ShallowFree;
				can be overridden to free objects 
				refered to by fields.
			}
		End;

End.
