/******************************************************************************\
 CTSMDesktop.cpp

	Desktop that sets the cursor for TSM

	by Dan Crevier
	version 1.8

	SCG		95/09/22	simplified a bit, added RTTI macro 
	Roms	95/11/08	adapted to THINK C / TCL 1.1.3
\ ******************************************************************************/

#include "CTSMDesktop.h"
#include <TextServices.h>

#if (TCL_VERSION) >= 0x02000000
TCL_DEFINE_CLASS_M1(CTSMDesktop, CDesktop);
#endif

//  Global Variables 
	
extern short 		gUsingTSM;			// Using Text Service Manager?

void CTSMDesktop::DispatchCursor(Point where, RgnHandle mouseRgn)
{
	Boolean tsmSetCursor = false;
	
	// if we are using TSM, let TSM have chance at setting cursor
    if (gUsingTSM)
    {
		tsmSetCursor = SetTSMCursor(where);
	}
	
	// if it didn't set it, let normal CDesktop handle it the normal way
	if (!tsmSetCursor)
		CDesktop::DispatchCursor(where, mouseRgn);
}
