/******************************************************************************
 CWASTEDlgText.c

	A class with some of the functionality of CDialogText, but using CWASTEText

	by Dan Crevier
	version 1.2

	Roms	95/11/08	adapted to THINK C / TCL 1.1.3
 ******************************************************************************/


#pragma once

#include "CWASTEText.h"

#include "CDialogText.h" // to get enum for dialogTextChanged

class CDialog;

class CWASTEDlgText : public CWASTEText
{
public:
#if (TCL_VERSION) >= 0x02000000
	TCL_DECLARE_CLASS
#endif

#ifndef THINK_C
	CWASTEDlgText();
	CWASTEDlgText(CView *anEnclosure, CBureaucrat *aSupervisor,
			short aWidth, short aHeight,
			short aHEncl, short aVEncl,
			SizingOption aHSizing = sizFIXEDSTICKY,
			SizingOption aVSizing = sizFIXEDSTICKY,
			short aLineWidth = -1, Boolean aScrollHoriz = 0,
			Boolean aIsRequired = FALSE, long aMaxValidLength = MAXLONG,
			Boolean aValidateOnResign = TRUE,
			Boolean supportObjects = true, Boolean supportUndo = true,
			Boolean supportDragAndDrop = true, Boolean outlineHighliting = true,
			Boolean drawOffscreen = false);

	virtual ~CWASTEDlgText();
#endif	// THINK_C

	void 		IWASTEDlgText(CView *anEnclosure, CBureaucrat *aSupervisor,
					short aWidth, short aHeight,
					short aHEncl, short aVEncl,
					SizingOption aHSizing, SizingOption aVSizing,
					short aLineWidth);

	virtual void 	IViewTemp(CView *anEnclosure, CBureaucrat *aSupervisor,
							Ptr viewData);

	virtual void 	DoKeyDown(char theChar, Byte keyCode, EventRecord *macEvent);
	virtual void 	GetTextString(StringPtr aString);
	virtual void 	PerformEditCommand(long theCommand);

	static pascal void WEPostUpdate(WEHandle hWE, long fixLength, long inputAreaStart,
						long inputAreaEnd, long pinRangeStart, long pinRangeEnd);

	// Object I/O
#if (TCL_VERSION) >= 0x02000000 && VA_COMPATIBLE_IO
	virtual void 		PutTo(CStream& stream);
	virtual void 		GetFrom(CStream& stream);
#endif
	
protected:

	void 			IWASTEDlgTextX(void);
	virtual void 	MakeBorder(void);

};
